#include "StdAfx.h"
#include "MonoCNFInstance.h"


MonoCNFInstance::MonoCNFInstance(void)
{
}


MonoCNFInstance::~MonoCNFInstance(void)
{
}

int MonoCNFInstance::GetCriticalIndex(const vector<int> perm)
{
	int CN = 0;
	m_helper.assign(m_m,0);

	int discovered_clauses = 0;
	int critical_index = 0;
	for (int i=0; i<m_n; i++)
	{
		int v = perm[i];
		int sz = m_instance[v].size();
		for(int j=0; j<sz; j++)
		{
			int u = m_instance[v][j];
			if(m_helper[u]==0)
			{
				m_helper[u]=1;
				discovered_clauses++;
			}
			if(discovered_clauses == m_m)
			{
				critical_index = i;
				return critical_index;
			}
		}
	}

	return critical_index;
}

void MonoCNFInstance::Load(string fName)
{
	string line;
	ifstream myfile;
	myfile.open (fName);

	int cnt = 0;
	while(std::getline(myfile, line))
	{		
		vector<std::string> elems;
		Split(line,' ',elems);
		
		if(elems.size()>0)
		{
			if(elems[0]=="p")
			{
				m_n = atoi(elems[2].c_str());
				m_m = atoi(elems[3].c_str());	
				m_helper.assign(0,m_m);
				for(int i=0; i<m_n; i++)
				{
					vector<int> tmp;
					m_instance.push_back(tmp);
				}
			}
			else if(elems[0]=="c")
			{
				// do nothing
			}			
			else{				
				for(int i=0;i<elems.size()-1; i++)
				{
					if(elems[i].compare("")!=0)
					{
						int x = atoi(elems[i].c_str())-1;
						m_instance[x].push_back(cnt);
					}					
				}	
				cnt++; // advance clause counter
			}
		}		
	}	

	myfile.close();
}

vector<string> MonoCNFInstance::Split(const string &s, char delim, vector<string> &elems)
{
	std::stringstream ss(s);
	std::string item;
	while(std::getline(ss, item, delim)) {
		elems.push_back(item);
	}
	return elems;
}

int MonoCNFInstance::GetVarsNum()
{
	return m_n;
}